Package org.apache.lucene.queries.function.valuesource

# Class MultiBoolFunction

java.lang.Object
org.apache.lucene.queries.function.ValueSource
org.apache.lucene.queries.function.valuesource.BoolFunction
org.apache.lucene.queries.function.valuesource.MultiBoolFunction

public abstract class MultiBoolFunction extends BoolFunction
Abstract `ValueSource` implementation which wraps multiple ValueSources and applies an extendible boolean function to their values.

## Field Summary

Fields
Modifier and Type
Field
Description
`protected final List<ValueSource>`
`sources`

## Constructor Summary

Constructors
Constructor
Description
`MultiBoolFunction(List<ValueSource> sources)`

## Method Summary

Modifier and Type
Method
Description
`void`
`createWeight(Map<Object,Object> context, IndexSearcher searcher)`
Implementations should propagate createWeight to sub-ValueSources which can optionally store weight info in the context.
`String`
`description()`
description of field, used in explain()
`boolean`
`equals(Object o)`
`protected abstract boolean`
`func(int doc, FunctionValues[] vals)`
`BoolDocValues`
`getValues(Map<Object,Object> context, LeafReaderContext readerContext)`
Gets the values for this reader and the context that was previously passed to createWeight().
`int`
`hashCode()`
`protected abstract String`
`name()`

### Methods inherited from class org.apache.lucene.queries.function.ValueSource

`asDoubleValuesSource, asLongValuesSource, fromDoubleValuesSource, getSortField, newContext, toString`

### Methods inherited from class java.lang.Object

`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

## Field Details

### sources

protected final List<ValueSource> sources

## Constructor Details

### MultiBoolFunction

public MultiBoolFunction(List<ValueSource> sources)

## Method Details

### name

protected abstract String name()

### func

protected abstract boolean func(int doc, FunctionValues[] vals) throws IOException

Throws:
  `IOException`

### getValues

public BoolDocValues getValues(Map<Object,Object> context, LeafReaderContext readerContext) throws IOException
Description copied from class: `ValueSource`
Gets the values for this reader and the context that was previously passed to createWeight(). The values must be consumed in a forward docID manner, and you must call this method again to iterate through the values again.

Specified by:
  `getValues` in class `ValueSource`
Throws:
  `IOException`

### description

public String description()
Description copied from class: `ValueSource`
description of field, used in explain()

Specified by:
  `description` in class `ValueSource`

### hashCode

public int hashCode()

Specified by:
  `hashCode` in class `ValueSource`

### equals

public boolean equals(Object o)

Specified by:
  `equals` in class `ValueSource`

### createWeight

public void createWeight(Map<Object,Object> context, IndexSearcher searcher) throws IOException
Description copied from class: `ValueSource`
Implementations should propagate createWeight to sub-ValueSources which can optionally store weight info in the context. The context object will be passed to getValues() where this info can be retrieved.

Overrides:
  `createWeight` in class `ValueSource`
Throws:
  `IOException`